
/*
 *  count.c
 *  Copyright (c) 1999 by Brad Proctor.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 */

/*
 * $Id: count.c,v 1.2 1999/06/14 22:23:37 brad Exp $
 */

#include <stdio.h>
#include <string.h>
#include "version.h"

#define invalid() \
{                 \
   fprintf(stderr, "%s: Invalid option: `%s'\n", argv[0], argv[i]);     \
   fputs("Try `count --help' for more information.", stderr); \
   return (1);   \
}

#define argument(a) \
{                   \
   fprintf(stderr, "%s: Option `"a"' requires an argument.\n", argv[0]);  \
   fputs("Try `count --help' for more information.", stderr);   \
   return (1); \
}

static char help_text[] =
{
   "Usage: count [option] [value]\n\n"
   "  -n         Omit newlines at end of number\n"
   "  -i n       Increment by n\n"
   "  --help     Print this help message\n"
   "  --version  Print the program version\n\n"
   "Report bugs to fredlie@sprynet.com"
};

static int  increment = 1;
static char flag_newline = 1;

/*
 * Main
 */

int main(int argc, char *argv[])
{
   int i;
   char *ptr;
   
   for(i = 1; i < argc; ++i)
   {
      ptr = argv[i];
      if(*ptr == '-')
      {
         switch(*++ptr)
         {
            case '-':
               ++ptr;
               if(!strcmp(ptr, "help"))
               {
                  puts(help_text);
                  return (0);
               }
               else if(!strcmp(ptr, "version"))
               {
                  puts("count (butils) "VERSION_STRING);
                  return (0);
               }
               else
                  invalid();
               break;
            case 'i':
               if(*++ptr != '\0')
                  invalid();
               if(++i < argc)
                  sscanf(argv[i], "%i", &increment);
               else
                  argument("-i");
               break;
            case 'n':
               if(*++ptr != '\0')
                  invalid();
               flag_newline = 0;
               break;
            default:
               invalid();
         }
      }
   }
   i = 0;
   if(flag_newline)
      while(1)
         printf("%d\n", i += increment);
   else
      while(1)
         printf("%d ", i += increment);
   return (0);
}
